#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

struct t_ldrec {
  /* lambda is x and vice versa */
  real x0;
  real v;
  real T;
  real T_ref;
  real x;
  real m;
  real nu_T;
  real ekin;
  real thetha;
  real v_thetha;
  struct ph_adapt* phc;
  struct lambda_ts* transitions;
  real ph_value; 
  real adapt_corr;
  real his_partner_const_b; /* needed for three state model */
  real macro_pka;
  real micro_diff;
  /* to build up spline barrier potential - June 2011*/
  int pts; /* number of points used to build the splines - at moment can be 3 to 7 */
  double** dqspline_l2_0; /* contains coefficients of the cubic splines when lambda of partner group is zero*/
  double** dqspline_l2_1; /* contains coefficients of the cubic splines when lambda of partner group is one */
  double* x_spline; /* contains x-coordinates of points for building the spline */
};

/* transisiton state array for the sliding window approach
   used in lambda_dynamics 4 */
struct lambda_ts{
    real ts;
    real lambda;

  /*adaptive barrier with gaussians*/
  float interval; /* interval where to monitor lambda */
  int counter;
  float scale; /* to sclae the correction */
  float max_energy; /* energy treshold: maximum energy (-(barrier+circle)) for adaptive barrier */
  int *l; /* stores the occurence of lambda values in bins during interval */
  float*  h; /* here the heigh of gaussians is stored */
  float*  f_old; /* here the previous landscape is stored */
  real corr;
};

/* ph dependence array for the lambda_dynamics 4 */
struct ph_adapt{
    struct ph_adapt* next;
    char* residue;
    real const_a;
    real const_b;
    real const_2;
    real const_3;
    real ph_a;
    real ph_b;
    real second_pka;
   /* for histidine */
    real param_his[4][5];
};

struct multi_lambda{
  FILE       *out;        /* output file for lambda dynamics data */
  FILE       *ou1;
  struct t_ldrec *lambda;
  real *chargeA;
  real *chargeB;
  int  *typeA,*typeB;
  real *massA;
  real *massB;
  char *name;
  int residue_number;
  float interval_adapt_barr; /* interval where to monitor lambda during adaptive barrier*/
  int *atoms;
  int nr_atoms;
  double dvdl;
  real barrier_l2_0;/* different barriers at lambda_partner 0 and 1 for 3/4 state model residues */
  real barrier_l2_1;
  struct multi_lambda* next;
  struct multi_lambda* his_partner;
  t_forcerec*  fr_l_dyn;
  /* to build up spline barrier potential - June 2011 */
  int pts; /* number of points used to build the splines - at moment can be 3 to 7 */

};

